/* Java Termination interface code.
   Copyright (C) 2001-2010 Roberto Bagnara <bagnara@cs.unipr.it>
   Copyright (C) 2010-2016 BUGSENG srl (http://bugseng.com)

This file is part of the Parma Polyhedra Library (PPL).

The PPL is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 3 of the License, or (at your
option) any later version.

The PPL is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02111-1307, USA.

For the most up-to-date information see the Parma Polyhedra Library
site: http://bugseng.com/products/ppl/ . */

#include "ppl_java_common_defs.hh"
#include "parma_polyhedra_library_Termination.h"
#include "parma_polyhedra_library_C_Polyhedron.h"
#include "parma_polyhedra_library_NNC_Polyhedron.h"
using namespace Parma_Polyhedra_Library;
using namespace Parma_Polyhedra_Library::Interfaces::Java;




JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_1C_1Polyhedron
(JNIEnv* env, jclass, jobject j_p) {
  try {
    C_Polyhedron* p_ptr
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p));
    return termination_test_MS(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_1C_1Polyhedron
(JNIEnv* env, jclass, jobject j_p) {
  try {
    C_Polyhedron* p_ptr
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p));
    return termination_test_PR(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_1NNC_1Polyhedron
(JNIEnv* env, jclass, jobject j_p) {
  try {
    NNC_Polyhedron* p_ptr
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p));
    return termination_test_MS(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_1NNC_1Polyhedron
(JNIEnv* env, jclass, jobject j_p) {
  try {
    NNC_Polyhedron* p_ptr
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p));
    return termination_test_PR(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_1C_1Polyhedron
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    C_Polyhedron* p_ptr
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_MS(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_1C_1Polyhedron
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    C_Polyhedron* p_ptr
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_PR(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_1NNC_1Polyhedron
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    NNC_Polyhedron* p_ptr
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_MS(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_1NNC_1Polyhedron
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    NNC_Polyhedron* p_ptr
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_PR(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_1C_1Polyhedron
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    C_Polyhedron* p_ptr
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_1C_1Polyhedron
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    C_Polyhedron* p_ptr
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_1NNC_1Polyhedron
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    NNC_Polyhedron* p_ptr
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_1NNC_1Polyhedron
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    NNC_Polyhedron* p_ptr
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_1C_1Polyhedron
(JNIEnv* env, jclass, jobject j_p,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    C_Polyhedron* p_ptr
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS(*p_ptr, *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_1NNC_1Polyhedron
(JNIEnv* env, jclass, jobject j_p,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    NNC_Polyhedron* p_ptr
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS(*p_ptr, *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}







JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_1C_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    C_Polyhedron* p_ptr_before
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_before));
    C_Polyhedron* p_ptr_after
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_after));
    return termination_test_MS_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_1C_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    C_Polyhedron* p_ptr_before
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_before));
    C_Polyhedron* p_ptr_after
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_after));
    return termination_test_PR_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_1NNC_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    NNC_Polyhedron* p_ptr_before
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_before));
    NNC_Polyhedron* p_ptr_after
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_after));
    return termination_test_MS_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_1NNC_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    NNC_Polyhedron* p_ptr_before
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_before));
    NNC_Polyhedron* p_ptr_after
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_after));
    return termination_test_PR_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_1C_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    C_Polyhedron* p_ptr_before
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_before));
    C_Polyhedron* p_ptr_after
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_MS_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_1C_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    C_Polyhedron* p_ptr_before
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_before));
    C_Polyhedron* p_ptr_after
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_PR_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_1NNC_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    NNC_Polyhedron* p_ptr_before
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_before));
    NNC_Polyhedron* p_ptr_after
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_MS_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_1NNC_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    NNC_Polyhedron* p_ptr_before
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_before));
    NNC_Polyhedron* p_ptr_after
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_PR_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_1C_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    C_Polyhedron* p_ptr_before
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_before));
    C_Polyhedron* p_ptr_after
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_1C_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    C_Polyhedron* p_ptr_before
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_before));
    C_Polyhedron* p_ptr_after
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_after));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_1NNC_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    NNC_Polyhedron* p_ptr_before
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_before));
    NNC_Polyhedron* p_ptr_after
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_1NNC_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    NNC_Polyhedron* p_ptr_before
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_before));
    NNC_Polyhedron* p_ptr_after
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_after));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_1C_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    C_Polyhedron* p_ptr_before
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_before));
    C_Polyhedron* p_ptr_after
      = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after,
                                            *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_1NNC_1Polyhedron_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    NNC_Polyhedron* p_ptr_before
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_before));
    NNC_Polyhedron* p_ptr_after
      = reinterpret_cast<NNC_Polyhedron*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after,
                                            *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11Grid
(JNIEnv* env, jclass, jobject j_p) {
  try {
    Grid* p_ptr
      = reinterpret_cast<Grid*>(get_ptr(env, j_p));
    return termination_test_MS(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11Grid
(JNIEnv* env, jclass, jobject j_p) {
  try {
    Grid* p_ptr
      = reinterpret_cast<Grid*>(get_ptr(env, j_p));
    return termination_test_PR(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11Grid
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    Grid* p_ptr
      = reinterpret_cast<Grid*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_MS(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11Grid
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    Grid* p_ptr
      = reinterpret_cast<Grid*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_PR(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11Grid
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    Grid* p_ptr
      = reinterpret_cast<Grid*>(get_ptr(env, j_p));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11Grid
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    Grid* p_ptr
      = reinterpret_cast<Grid*>(get_ptr(env, j_p));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11Grid
(JNIEnv* env, jclass, jobject j_p,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    Grid* p_ptr
      = reinterpret_cast<Grid*>(get_ptr(env, j_p));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS(*p_ptr, *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}







JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11Grid_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    Grid* p_ptr_before
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_before));
    Grid* p_ptr_after
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_after));
    return termination_test_MS_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11Grid_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    Grid* p_ptr_before
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_before));
    Grid* p_ptr_after
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_after));
    return termination_test_PR_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11Grid_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    Grid* p_ptr_before
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_before));
    Grid* p_ptr_after
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_MS_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11Grid_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    Grid* p_ptr_before
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_before));
    Grid* p_ptr_after
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_PR_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11Grid_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    Grid* p_ptr_before
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_before));
    Grid* p_ptr_after
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11Grid_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    Grid* p_ptr_before
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_before));
    Grid* p_ptr_after
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_after));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11Grid_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    Grid* p_ptr_before
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_before));
    Grid* p_ptr_after
      = reinterpret_cast<Grid*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after,
                                            *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11Rational_Box
(JNIEnv* env, jclass, jobject j_p) {
  try {
    Rational_Box* p_ptr
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p));
    return termination_test_MS(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11Rational_Box
(JNIEnv* env, jclass, jobject j_p) {
  try {
    Rational_Box* p_ptr
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p));
    return termination_test_PR(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11Rational_Box
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    Rational_Box* p_ptr
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_MS(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11Rational_Box
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    Rational_Box* p_ptr
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_PR(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11Rational_Box
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    Rational_Box* p_ptr
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11Rational_Box
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    Rational_Box* p_ptr
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11Rational_Box
(JNIEnv* env, jclass, jobject j_p,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    Rational_Box* p_ptr
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS(*p_ptr, *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}







JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11Rational_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    Rational_Box* p_ptr_before
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_before));
    Rational_Box* p_ptr_after
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_after));
    return termination_test_MS_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11Rational_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    Rational_Box* p_ptr_before
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_before));
    Rational_Box* p_ptr_after
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_after));
    return termination_test_PR_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11Rational_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    Rational_Box* p_ptr_before
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_before));
    Rational_Box* p_ptr_after
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_MS_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11Rational_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    Rational_Box* p_ptr_before
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_before));
    Rational_Box* p_ptr_after
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_PR_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11Rational_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    Rational_Box* p_ptr_before
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_before));
    Rational_Box* p_ptr_after
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11Rational_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    Rational_Box* p_ptr_before
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_before));
    Rational_Box* p_ptr_after
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_after));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11Rational_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    Rational_Box* p_ptr_before
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_before));
    Rational_Box* p_ptr_after
      = reinterpret_cast<Rational_Box*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after,
                                            *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11BD_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p) {
  try {
    BD_Shape<mpz_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p));
    return termination_test_MS(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11BD_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p) {
  try {
    BD_Shape<mpz_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p));
    return termination_test_PR(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11BD_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    BD_Shape<mpz_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_MS(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11BD_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    BD_Shape<mpz_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_PR(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11BD_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    BD_Shape<mpz_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11BD_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    BD_Shape<mpz_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11BD_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    BD_Shape<mpz_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS(*p_ptr, *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}







JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11BD_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    BD_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    return termination_test_MS_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11BD_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    BD_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    return termination_test_PR_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11BD_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    BD_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_MS_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11BD_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    BD_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_PR_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11BD_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    BD_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11BD_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    BD_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11BD_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    BD_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after,
                                            *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11BD_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p) {
  try {
    BD_Shape<mpq_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p));
    return termination_test_MS(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11BD_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p) {
  try {
    BD_Shape<mpq_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p));
    return termination_test_PR(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11BD_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    BD_Shape<mpq_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_MS(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11BD_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    BD_Shape<mpq_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_PR(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11BD_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    BD_Shape<mpq_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11BD_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    BD_Shape<mpq_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11BD_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    BD_Shape<mpq_class>* p_ptr
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS(*p_ptr, *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}







JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11BD_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    BD_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    return termination_test_MS_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11BD_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    BD_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    return termination_test_PR_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11BD_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    BD_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_MS_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11BD_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    BD_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_PR_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11BD_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    BD_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11BD_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    BD_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11BD_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    BD_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    BD_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<BD_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after,
                                            *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11Octagonal_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p));
    return termination_test_MS(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11Octagonal_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p));
    return termination_test_PR(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11Octagonal_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_MS(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11Octagonal_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_PR(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11Octagonal_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11Octagonal_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11Octagonal_Shape_mpz_class
(JNIEnv* env, jclass, jobject j_p,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS(*p_ptr, *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}







JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11Octagonal_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    return termination_test_MS_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11Octagonal_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    return termination_test_PR_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11Octagonal_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_MS_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11Octagonal_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_PR_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11Octagonal_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11Octagonal_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11Octagonal_Shape_mpz_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    Octagonal_Shape<mpz_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpz_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpz_class>*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after,
                                            *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11Octagonal_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p));
    return termination_test_MS(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11Octagonal_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p));
    return termination_test_PR(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11Octagonal_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_MS(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11Octagonal_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_PR(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11Octagonal_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11Octagonal_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11Octagonal_Shape_mpq_class
(JNIEnv* env, jclass, jobject j_p,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS(*p_ptr, *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}







JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11Octagonal_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    return termination_test_MS_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11Octagonal_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    return termination_test_PR_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11Octagonal_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_MS_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11Octagonal_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_PR_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11Octagonal_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11Octagonal_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11Octagonal_Shape_mpq_class_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    Octagonal_Shape<mpq_class>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<mpq_class>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<mpq_class>*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after,
                                            *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11Double_Box
(JNIEnv* env, jclass, jobject j_p) {
  try {
    Double_Box* p_ptr
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p));
    return termination_test_MS(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11Double_Box
(JNIEnv* env, jclass, jobject j_p) {
  try {
    Double_Box* p_ptr
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p));
    return termination_test_PR(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11Double_Box
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    Double_Box* p_ptr
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_MS(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11Double_Box
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    Double_Box* p_ptr
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_PR(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11Double_Box
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    Double_Box* p_ptr
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11Double_Box
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    Double_Box* p_ptr
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11Double_Box
(JNIEnv* env, jclass, jobject j_p,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    Double_Box* p_ptr
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS(*p_ptr, *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}







JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11Double_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    Double_Box* p_ptr_before
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_before));
    Double_Box* p_ptr_after
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_after));
    return termination_test_MS_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11Double_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    Double_Box* p_ptr_before
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_before));
    Double_Box* p_ptr_after
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_after));
    return termination_test_PR_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11Double_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    Double_Box* p_ptr_before
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_before));
    Double_Box* p_ptr_after
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_MS_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11Double_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    Double_Box* p_ptr_before
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_before));
    Double_Box* p_ptr_after
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_PR_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11Double_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    Double_Box* p_ptr_before
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_before));
    Double_Box* p_ptr_after
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11Double_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    Double_Box* p_ptr_before
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_before));
    Double_Box* p_ptr_after
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_after));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11Double_Box_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    Double_Box* p_ptr_before
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_before));
    Double_Box* p_ptr_after
      = reinterpret_cast<Double_Box*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after,
                                            *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11BD_Shape_double
(JNIEnv* env, jclass, jobject j_p) {
  try {
    BD_Shape<double>* p_ptr
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p));
    return termination_test_MS(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11BD_Shape_double
(JNIEnv* env, jclass, jobject j_p) {
  try {
    BD_Shape<double>* p_ptr
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p));
    return termination_test_PR(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11BD_Shape_double
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    BD_Shape<double>* p_ptr
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_MS(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11BD_Shape_double
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    BD_Shape<double>* p_ptr
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_PR(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11BD_Shape_double
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    BD_Shape<double>* p_ptr
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11BD_Shape_double
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    BD_Shape<double>* p_ptr
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11BD_Shape_double
(JNIEnv* env, jclass, jobject j_p,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    BD_Shape<double>* p_ptr
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS(*p_ptr, *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}







JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11BD_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    BD_Shape<double>* p_ptr_before
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_before));
    BD_Shape<double>* p_ptr_after
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_after));
    return termination_test_MS_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11BD_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    BD_Shape<double>* p_ptr_before
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_before));
    BD_Shape<double>* p_ptr_after
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_after));
    return termination_test_PR_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11BD_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    BD_Shape<double>* p_ptr_before
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_before));
    BD_Shape<double>* p_ptr_after
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_MS_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11BD_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    BD_Shape<double>* p_ptr_before
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_before));
    BD_Shape<double>* p_ptr_after
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_PR_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11BD_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    BD_Shape<double>* p_ptr_before
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_before));
    BD_Shape<double>* p_ptr_after
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11BD_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    BD_Shape<double>* p_ptr_before
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_before));
    BD_Shape<double>* p_ptr_after
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_after));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11BD_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    BD_Shape<double>* p_ptr_before
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_before));
    BD_Shape<double>* p_ptr_after
      = reinterpret_cast<BD_Shape<double>*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after,
                                            *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11Octagonal_Shape_double
(JNIEnv* env, jclass, jobject j_p) {
  try {
    Octagonal_Shape<double>* p_ptr
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p));
    return termination_test_MS(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11Octagonal_Shape_double
(JNIEnv* env, jclass, jobject j_p) {
  try {
    Octagonal_Shape<double>* p_ptr
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p));
    return termination_test_PR(*p_ptr);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11Octagonal_Shape_double
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    Octagonal_Shape<double>* p_ptr
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_MS(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11Octagonal_Shape_double
(JNIEnv* env, jclass, jobject j_p, jobject j_g) {
  try {
    Octagonal_Shape<double>* p_ptr
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p));
    Generator g(point());
    if (one_affine_ranking_function_PR(*p_ptr, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11Octagonal_Shape_double
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    Octagonal_Shape<double>* p_ptr
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11Octagonal_Shape_double
(JNIEnv* env, jclass, jobject j_p, jobject j_ph) {
  try {
    Octagonal_Shape<double>* p_ptr
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR(*p_ptr, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11Octagonal_Shape_double
(JNIEnv* env, jclass, jobject j_p,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    Octagonal_Shape<double>* p_ptr
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS(*p_ptr, *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}







JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1MS_11Octagonal_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    Octagonal_Shape<double>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<double>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_after));
    return termination_test_MS_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_termination_1test_1PR_11Octagonal_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after) {
  try {
    Octagonal_Shape<double>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<double>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_after));
    return termination_test_PR_2(*p_ptr_before, *p_ptr_after);
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1MS_11Octagonal_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    Octagonal_Shape<double>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<double>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_MS_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}


JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Termination_one_1affine_1ranking_1function_1PR_11Octagonal_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_g) {
  try {
    Octagonal_Shape<double>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<double>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_after));
    Generator g(point());
    if (one_affine_ranking_function_PR_2(*p_ptr_before, *p_ptr_after, g)) {
      jobject j_g_result = build_java_generator(env, g);;
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return 0;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1MS_11Octagonal_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    Octagonal_Shape<double>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<double>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph = new C_Polyhedron();
    all_affine_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}


JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1ranking_1functions_1PR_11Octagonal_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after, jobject j_ph) {
  try {
    Octagonal_Shape<double>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<double>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_after));
    NNC_Polyhedron* ph = new NNC_Polyhedron();
    all_affine_ranking_functions_PR_2(*p_ptr_before, *p_ptr_after, *ph);
    set_ptr(env, j_ph, ph);
  }
  CATCH_ALL;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Termination_all_1affine_1quasi_1ranking_1functions_1MS_11Octagonal_Shape_double_12
(JNIEnv* env, jclass, jobject j_p_before, jobject j_p_after,
 jobject j_ph_decreasing, jobject j_ph_bounded) {
  try {
    Octagonal_Shape<double>* p_ptr_before
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_before));
    Octagonal_Shape<double>* p_ptr_after
      = reinterpret_cast<Octagonal_Shape<double>*>(get_ptr(env, j_p_after));
    C_Polyhedron* ph_decreasing = new C_Polyhedron();
    C_Polyhedron* ph_bounded = new C_Polyhedron();
    all_affine_quasi_ranking_functions_MS_2(*p_ptr_before, *p_ptr_after,
                                            *ph_decreasing, *ph_bounded);
    set_ptr(env, j_ph_decreasing, ph_decreasing);
    set_ptr(env, j_ph_bounded, ph_bounded);
  }
  CATCH_ALL;
}







